diff --git a/common/src/main/scala/services/teamwork/SquadService.scala b/common/src/main/scala/services/teamwork/SquadService.scala
index 245c3a29..070cdacc 100644
--- a/common/src/main/scala/services/teamwork/SquadService.scala
+++ b/common/src/main/scala/services/teamwork/SquadService.scala
@@ -3,12 +3,13 @@ package services.teamwork
 
 import akka.actor.Actor
 import net.psforever.objects.Player
-import net.psforever.objects.teamwork.{Member, Squad}
+import net.psforever.objects.teamwork.Squad
 import net.psforever.packet.game._
-import net.psforever.types.{PlanetSideEmpire, Vector3}
+import net.psforever.types.{PlanetSideEmpire, SquadRequestType, Vector3}
 import services.{GenericEventBus, Service}
 
 import scala.collection.concurrent.TrieMap
+import scala.collection.mutable
 import scala.collection.mutable.ListBuffer
 
 //import scala.concurrent.duration._
@@ -22,11 +23,35 @@ class SquadService extends Actor {
     PlanetSideEmpire.NC -> ListBuffer.empty,
     PlanetSideEmpire.VS -> ListBuffer.empty
   )
+  private val bids : mutable.LongMap[(PlanetSideGUID, Int)] = mutable.LongMap[(PlanetSideGUID, Int)]()
 
   private [this] val log = org.log4s.getLogger
 
   override def preStart = {
     log.info("Starting...")
+
+    val testSquad = new Squad(PlanetSideGUID(3), PlanetSideEmpire.VS)
+    testSquad.Task = "\\#66CCFF Sentinels of Auraxis\\#FFFFFF ... \\#40FF40 Squad Up!!"
+    testSquad.ZoneId = 5
+    testSquad.Membership(0).Name = "Wizkid45"
+    testSquad.Membership(0).CharId = 30910985L
+    testSquad.Membership(0).ZoneId = 5
+    testSquad.Membership(0).Position = Vector3(5526.5234f, 3818.7344f, 54.59375f)
+    testSquad.Membership(1).Name = "xoBLADEox"
+    testSquad.Membership(1).CharId = 42781919L
+    testSquad.Membership(1).ZoneId = 5
+    testSquad.Membership(1).Position = Vector3(4673.5312f, 2604.8047f, 40.015625f)
+    testSquad.Membership(3).Name = "cabal0428"
+    testSquad.Membership(3).CharId = 353380L
+    testSquad.Membership(3).ZoneId = 5
+    testSquad.Membership(3).Position = Vector3(4727.492f, 2613.5312f, 51.390625f)
+    testSquad.Membership(4).Name = "xSkiku"
+    testSquad.Membership(4).CharId = 41588340L
+    testSquad.Membership(4).ZoneId = 5
+    testSquad.Membership(4).Position = Vector3(3675.0f, 4789.8047f, 63.21875f)
+    idToSquad(PlanetSideGUID(3)) = testSquad
+    testSquad.Listed = true
+    UpdateSquadList(testSquad, List())
   }
 
   def GetNextSquadId() : PlanetSideGUID = {
@@ -55,7 +80,7 @@ class SquadService extends Actor {
     val name = player.Name
     val squadOut = opt match {
       case Some(squad) =>
-        if(squad.Leader.equals(name)) {
+        if(squad.Leader.Name.equals(name)) {
           squad
         }
         else {
@@ -64,7 +89,7 @@ class SquadService extends Actor {
 
       case None =>
         memberToSquad.get(name) match {
-          case Some(squad) if squad.Leader.equals(name) =>
+          case Some(squad) if squad.Leader.Name.equals(name) =>
             squad
           case _ =>
             val faction = player.Faction
@@ -115,7 +140,7 @@ class SquadService extends Actor {
       SquadEvents.unsubscribe(sender())
       memberToSquad.get(name) match {
         case Some(squad) =>
-          if(squad.Leader.equals(name)) {
+          if(squad.Leader.Name.equals(name)) {
             //we were the leader
             if(squad.Membership.count(p => p.Name.equals("")) > 1) {
               //other players were in the squad; publicly disband it
@@ -144,190 +169,218 @@ class SquadService extends Actor {
           }
         case None => ;
       }
-      //TODO leave squad, if joined to one, and perform clean-up
+    //TODO leave squad, if joined to one, and perform clean-up
 
     case Service.Leave(None) | Service.LeaveAll() => ;
 
-    case SquadServiceMessage.SquadDefinitionAction(tplayer, zone_ordinal_number, guid, _, action) =>
-      import net.psforever.packet.game.SquadAction._
-      val squadOpt = GetParticipatingSquad(tplayer, zone_ordinal_number)
-      action match {
-        case SaveSquadDefinition() =>
-
-        case ChangeSquadPurpose(purpose) =>
-          log.info(s"${tplayer.Name}-${tplayer.Faction} has changed his squad's task to $purpose")
-          val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
-          squad.Task = purpose
-          UpdateSquadList(squad, List(SquadInfo.Field.Task))
-          UpdateSquadDetail(squad)
-
-        case ChangeSquadZone(zone) =>
-          log.info(s"${tplayer.Name}-${tplayer.Faction} has changed squad's ops zone to $zone")
-          val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
-          squad.ZoneId = zone.zoneId.toInt
-          UpdateSquadList(squad, List(SquadInfo.Field.ZoneId))
-          UpdateSquadDetail(squad)
-
-        case CloseSquadMemberPosition(position) =>
-          val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
-          squad.Availability.lift(position) match {
-            case Some(true) =>
-              squad.Availability.update(position, false)
-              log.info(s"${tplayer.Name}-${tplayer.Faction} has closed the #$position position in squad")
-              val memberPosition = squad.Membership(position)
-              val listingChanged = if(memberPosition.Name.nonEmpty) {
-                List(SquadInfo.Field.Size, SquadInfo.Field.Capacity)
+    case SquadServiceMessage(tplayer, squad_action) => squad_action match {
+      case SquadAction.Membership(request_type, char_id, optional_char_id, name, unk5) => request_type match {
+        case SquadRequestType.Accept =>
+          bids.get(char_id) match {
+            case Some((squadGUID, line)) if idToSquad.get(squadGUID).nonEmpty =>
+              //join squad
+              val squad = idToSquad(squadGUID)
+              val position = squad.Membership(line)
+              if(squad.Availability(line) && position.CharId == 0 &&
+                tplayer.Certifications.intersect(position.Requirements) == position.Requirements) {
+                position.Name = tplayer.Name
+                position.CharId = char_id
+                position.Health = tplayer.Health
+                position.Armor = tplayer.Armor
+                position.Position = tplayer.Position
+                position.ZoneId = 13
+                memberToSquad(tplayer.Name) = squad
+                sender ! SquadServiceResponse("", SquadResponse.Join(
+                  squad,
+                  squad.Membership.zipWithIndex.collect({ case (member, index) if member.CharId != 0 => index }).toList
+                ))
               }
-              else {
-                List(SquadInfo.Field.Capacity)
-              }
-              memberPosition.Close()
-              UpdateSquadList(squad, listingChanged)
-              UpdateSquadDetail(squad)
-            case Some(false) | None => ;
+              bids.remove(char_id)
+            case _ => ;
           }
 
-        case AddSquadMemberPosition(position) =>
-          val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
-          squad.Availability.lift(position) match {
-            case Some(false) =>
-              log.info(s"${tplayer.Name}-${tplayer.Faction} has opened the #$position position in squad")
-              squad.Availability.update(position, true)
-              UpdateSquadList(squad, List(SquadInfo.Field.Capacity))
-              UpdateSquadDetail(squad)
-            case Some(true) | None => ;
-          }
-
-        case ChangeSquadMemberRequirementsRole(position, role) =>
-          val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
-          squad.Availability.lift(position) match {
-            case Some(true) =>
-              log.info(s"${tplayer.Name}-${tplayer.Faction} has changed the role of squad position #$position")
-              squad.Membership(position).Role = role
-              UpdateSquadDetail(squad)
-            case Some(false) | None => ;
-          }
-
-        case ChangeSquadMemberRequirementsDetailedOrders(position, orders) =>
-          val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
-          squad.Availability.lift(position) match {
-            case Some(true) =>
-              log.info(s"${tplayer.Name}-${tplayer.Faction} has changed the orders for squad position #$position")
-              squad.Membership(position).Orders = orders
-              UpdateSquadDetail(squad)
-            case Some(false) | None => ;
-          }
-
-        case ChangeSquadMemberRequirementsCertifications(position, certs) =>
-          val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
-          squad.Availability.lift(position) match {
-            case Some(true) =>
-              log.info(s"${tplayer.Name}-${tplayer.Faction} has changed the requirements for squad position #$position")
-              squad.Membership(position).Requirements = certs
-              UpdateSquadDetail(squad)
-            case Some(false) | None => ;
-          }
-
-        case LocationFollowsSquadLead(state) =>
-          val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
-          if(state) {
-            log.info(s"${tplayer.Name}-${tplayer.Faction} has moves the rally to the leader's position")
-          }
-          else {
-            log.info(s"${tplayer.Name}-${tplayer.Faction} has let the rally move freely")
-          }
-          squad.LocationFollowsSquadLead = state
-
-        case AutoApproveInvitationRequests(state) =>
-          val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
-          if(state) {
-            log.info(s"${tplayer.Name}-${tplayer.Faction} is allowing all requests to join the squad")
-          }
-          else {
-            log.info(s"${tplayer.Name}-${tplayer.Faction} has started screening invitation requests")
-          }
-          squad.AutoApproveInvitationRequests = state
-
-        case SelectRoleForYourself(line) =>
-          //TODO need to ask permission from the squad leader, unless our character is the squad leader or already currently in the squad
-          val name = tplayer.Name
-          squadOpt match {
-            case Some(squad) =>
-              {
-                if(squad.Availability(line))
-                  squad.Membership.lift(line)
-                else
-                  None
-              } match {
-                case Some(desiredPosition : Member)
-                  if desiredPosition.Requirements.intersect(tplayer.Certifications) == desiredPosition.Requirements =>
-                  //our character is qualified for this new position
-                  if(squad.Leader.equals(tplayer.Name)) {
-                    squad.LeaderPositionIndex = line //update
-                  }
-                  val hadPreviousPosition = squad.Membership.find(_.Name == name) match {
-                    case Some(currentPosition)=>
-                      currentPosition.Name = ""
-                      currentPosition.CharId = 0L
-                      currentPosition.ZoneId = 0
-                      currentPosition.Health = 0
-                      currentPosition.Armor = 0
-                      currentPosition.Position = Vector3.Zero
-                      true
-                    case None =>
-                      false
-                  }
-                  desiredPosition.Name = name
-                  desiredPosition.CharId = tplayer.CharId
-                  desiredPosition.ZoneId = zone_ordinal_number
-                  desiredPosition.Health = tplayer.Health
-                  desiredPosition.Armor = tplayer.Armor
-                  desiredPosition.Position = tplayer.Position
-                  if(!hadPreviousPosition) {
-                    UpdateSquadList(squad, List(SquadInfo.Field.Size))
-                  }
-                  UpdateSquadDetail(squad)
-                case None => ;
-              }
-
-            case None => ;
-          }
-
-        case ListSquad() =>
-          val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
-          if(!squad.Listed) {
-            log.info(s"${tplayer.Name}-${tplayer.Faction} has opened recruitment for this squad")
-            squad.Listed = true
-          }
-          UpdateSquadList(squad, List())
-
-        case ResetAll() =>
-          val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
-          squad.Task = ""
-          squad.ZoneId = None
-          squad.Availability.indices.foreach { i =>
-            squad.Availability.update(i, true)
-          }
-          squad.Membership.foreach(position => {
-            position.Role = ""
-            position.Orders = ""
-            position.Requirements = Set()
-          })
-          UpdateSquadList(squad, List(SquadInfo.Field.Task, SquadInfo.Field.ZoneId, SquadInfo.Field.Size, SquadInfo.Field.Capacity))
-          UpdateSquadDetail(squad)
-
-        case DisplaySquad() =>
-          idToSquad.get(guid) match {
-            case Some(squad) =>
-              sender ! SquadServiceResponse(s"${tplayer.Name}/Squad", GenSquadDetail(squad))
-            case None => ;
+        case SquadRequestType.Leave =>
+          if(optional_char_id.contains(char_id)) {
+            //we're leaving the squad on our own
+            val name = tplayer.Name
+            val squad = memberToSquad(name)
+            val membership = squad.Membership.zipWithIndex
+            val (member, index) = membership
+              .find { case (_member, _) => _member.Name == name }
+              .get
+            val updateList = membership.collect({ case (_member, _) if _member.CharId > 0 => (_member.CharId, index) }).toList
+            memberToSquad.remove(name)
+            member.Name = ""
+            member.CharId = 0
+            sender ! SquadServiceResponse("", SquadResponse.Leave(squad, updateList))
           }
 
         case _ => ;
       }
 
-    case msg =>
-      log.info(s"Unhandled message $msg from $sender")
+      case SquadAction.Definition(tplayer : Player, zone_ordinal_number : Int, guid : PlanetSideGUID, line : Int, action : SquadAction) =>
+        import net.psforever.packet.game.SquadAction._
+        val squadOpt = GetParticipatingSquad(tplayer, zone_ordinal_number)
+        action match {
+          case SaveSquadDefinition() =>
+
+          case ChangeSquadPurpose(purpose) =>
+            log.info(s"${tplayer.Name}-${tplayer.Faction} has changed his squad's task to $purpose")
+            val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
+            squad.Task = purpose
+            UpdateSquadList(squad, List(SquadInfo.Field.Task))
+            UpdateSquadDetail(squad)
+
+          case ChangeSquadZone(zone) =>
+            log.info(s"${tplayer.Name}-${tplayer.Faction} has changed squad's ops zone to $zone")
+            val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
+            squad.ZoneId = zone.zoneId.toInt
+            UpdateSquadList(squad, List(SquadInfo.Field.ZoneId))
+            UpdateSquadDetail(squad)
+
+          case CloseSquadMemberPosition(position) =>
+            val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
+            squad.Availability.lift(position) match {
+              case Some(true) =>
+                squad.Availability.update(position, false)
+                log.info(s"${tplayer.Name}-${tplayer.Faction} has closed the #$position position in squad")
+                val memberPosition = squad.Membership(position)
+                val listingChanged = if(memberPosition.Name.nonEmpty) {
+                  List(SquadInfo.Field.Size, SquadInfo.Field.Capacity)
+                }
+                else {
+                  List(SquadInfo.Field.Capacity)
+                }
+                memberPosition.Close()
+                UpdateSquadList(squad, listingChanged)
+                UpdateSquadDetail(squad)
+              case Some(false) | None => ;
+            }
+
+          case AddSquadMemberPosition(position) =>
+            val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
+            squad.Availability.lift(position) match {
+              case Some(false) =>
+                log.info(s"${tplayer.Name}-${tplayer.Faction} has opened the #$position position in squad")
+                squad.Availability.update(position, true)
+                UpdateSquadList(squad, List(SquadInfo.Field.Capacity))
+                UpdateSquadDetail(squad)
+              case Some(true) | None => ;
+            }
+
+          case ChangeSquadMemberRequirementsRole(position, role) =>
+            val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
+            squad.Availability.lift(position) match {
+              case Some(true) =>
+                log.info(s"${tplayer.Name}-${tplayer.Faction} has changed the role of squad position #$position")
+                squad.Membership(position).Role = role
+                UpdateSquadDetail(squad)
+              case Some(false) | None => ;
+            }
+
+          case ChangeSquadMemberRequirementsDetailedOrders(position, orders) =>
+            val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
+            squad.Availability.lift(position) match {
+              case Some(true) =>
+                log.info(s"${tplayer.Name}-${tplayer.Faction} has changed the orders for squad position #$position")
+                squad.Membership(position).Orders = orders
+                UpdateSquadDetail(squad)
+              case Some(false) | None => ;
+            }
+
+          case ChangeSquadMemberRequirementsCertifications(position, certs) =>
+            val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
+            squad.Availability.lift(position) match {
+              case Some(true) =>
+                log.info(s"${tplayer.Name}-${tplayer.Faction} has changed the requirements for squad position #$position")
+                squad.Membership(position).Requirements = certs
+                UpdateSquadDetail(squad)
+              case Some(false) | None => ;
+            }
+
+          case LocationFollowsSquadLead(state) =>
+            val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
+            if(state) {
+              log.info(s"${tplayer.Name}-${tplayer.Faction} has moves the rally to the leader's position")
+            }
+            else {
+              log.info(s"${tplayer.Name}-${tplayer.Faction} has let the rally move freely")
+            }
+            squad.LocationFollowsSquadLead = state
+
+          case AutoApproveInvitationRequests(state) =>
+            val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
+            if(state) {
+              log.info(s"${tplayer.Name}-${tplayer.Faction} is allowing all requests to join the squad")
+            }
+            else {
+              log.info(s"${tplayer.Name}-${tplayer.Faction} has started screening invitation requests")
+            }
+            squad.AutoApproveInvitationRequests = state
+
+          case SelectRoleForYourself(position) =>
+            //TODO need to ask permission from the squad leader, unless our character is the squad leader or already currently in the squad
+            val name = tplayer.Name
+            squadOpt match {
+              case Some(squad) if squad.GUID == guid =>
+              //already a member of this squad; swap positions freely
+              case Some(squad) =>
+              //not a member of the requesting squad; do nothing
+              case None =>
+                //not a member of any squad; consider request of joining the target squad
+                idToSquad.get(guid) match {
+                  case Some(squad) =>
+                    val member = squad.Membership(position)
+                    if(squad.Availability(position) && member.CharId == 0 &&
+                      tplayer.Certifications.intersect(member.Requirements) == member.Requirements) {
+                      bids(tplayer.CharId) = (guid, position)
+                      val leader = squad.Leader
+                      //TODO need to ask permission from the squad leader, unless auto-approve is in effect
+                      sender ! SquadServiceResponse("", SquadResponse.Membership(SquadRequestType.Invite, 0, 0, leader.CharId, Some(tplayer.CharId), leader.Name, false, None))
+                    }
+
+                  case None =>
+                  //squad does not exist!? assume old data
+                  //reload squad list data and blank the squad definition the user is looking at
+                }
+            }
+
+          case ListSquad() =>
+            val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
+            if(!squad.Listed) {
+              log.info(s"${tplayer.Name}-${tplayer.Faction} has opened recruitment for this squad")
+              squad.Listed = true
+            }
+            UpdateSquadList(squad, List())
+
+          case ResetAll() =>
+            val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
+            squad.Task = ""
+            squad.ZoneId = None
+            squad.Availability.indices.foreach { i =>
+              squad.Availability.update(i, true)
+            }
+            squad.Membership.foreach(position => {
+              position.Role = ""
+              position.Orders = ""
+              position.Requirements = Set()
+            })
+            UpdateSquadList(squad, List(SquadInfo.Field.Task, SquadInfo.Field.ZoneId, SquadInfo.Field.Size, SquadInfo.Field.Capacity))
+            UpdateSquadDetail(squad)
+
+          case DisplaySquad() =>
+            idToSquad.get(guid) match {
+              case Some(squad) =>
+                sender ! SquadServiceResponse(s"${tplayer.Name}/Squad", GenSquadDetail(squad))
+              case None => ;
+            }
+
+          case _ => ;
+        }
+
+      case msg =>
+        log.info(s"Unhandled message $msg from $sender")
+    }
   }
 
   def UpdateSquadList(squad : Squad, listingChanged : List[Int]) : Unit = {
@@ -380,7 +433,7 @@ class SquadService extends Actor {
   def GenSquadDetail(squad : Squad) : SquadResponse.Detail = {
     SquadResponse.Detail(
       squad.GUID,
-      squad.Leader,
+      squad.Leader.Name,
       squad.Task,
       PlanetSideZoneID(squad.ZoneId),
       squad.Membership.zipWithIndex.map({ case (p, index) =>
@@ -410,7 +463,7 @@ class SquadService extends Actor {
 object SquadService {
   def Publish(squad : Squad) : SquadInfo = {
     SquadInfo(
-      squad.Leader,
+      squad.Leader.Name,
       squad.Task,
       PlanetSideZoneID(squad.ZoneId),
       squad.Size,
diff --git a/common/src/main/scala/services/teamwork/SquadServiceMessage.scala b/common/src/main/scala/services/teamwork/SquadServiceMessage.scala
index 2157d44c..1e6c5559 100644
--- a/common/src/main/scala/services/teamwork/SquadServiceMessage.scala
+++ b/common/src/main/scala/services/teamwork/SquadServiceMessage.scala
@@ -2,12 +2,9 @@
 package services.teamwork
 
 import net.psforever.objects.Player
-import net.psforever.packet.game.{PlanetSideGUID, SquadAction}
 
-final case class SquadServiceMessage(forChannel : String, actionMessage : Any)
+final case class SquadServiceMessage(tplayer : Player, actionMessage : Any)
 
 object SquadServiceMessage {
-  final case class SquadDefinitionAction(player : Player, zone_ordinal_number : Int, guid : PlanetSideGUID, line : Int, action : SquadAction)
-
   final case class RecoverSquadMembership()
 }
diff --git a/common/src/test/scala/game/SquadDetailDefinitionUpdateMessageTest.scala b/common/src/test/scala/game/SquadDetailDefinitionUpdateMessageTest.scala
index 8f04cf53..9e3fd2c1 100644
--- a/common/src/test/scala/game/SquadDetailDefinitionUpdateMessageTest.scala
+++ b/common/src/test/scala/game/SquadDetailDefinitionUpdateMessageTest.scala
@@ -146,7 +146,7 @@ class SquadDetailDefinitionUpdateMessageTest extends Specification {
           guid mustEqual PlanetSideGUID(3)
           detail match {
             case SquadDetail(None, None, None, None, None, None, None, None, Some(members)) =>
-              members.size mustEqual 2
+              members.size mustEqual 1
               members.head.index mustEqual 5
               members.head.info match {
                 case Some(SquadPositionDetail(Some(is_closed), None, None, None, None, None)) =>
@@ -169,7 +169,7 @@ class SquadDetailDefinitionUpdateMessageTest extends Specification {
           guid mustEqual PlanetSideGUID(7)
           detail match {
             case SquadDetail(None, None, None, None, None, None, None, None, Some(members)) =>
-              members.size mustEqual 2
+              members.size mustEqual 1
               members.head.index mustEqual 0
               members.head.info match {
                 case Some(SquadPositionDetail(None, Some(role), None, None, None, None)) =>
@@ -192,7 +192,7 @@ class SquadDetailDefinitionUpdateMessageTest extends Specification {
           guid mustEqual PlanetSideGUID(1)
           detail match {
             case SquadDetail(None, None, None, None, None, None, None, None, Some(members)) =>
-              members.size mustEqual 2
+              members.size mustEqual 1
               members.head.index mustEqual 6
               members.head.info match {
                 case Some(SquadPositionDetail(None, Some(role), None, Some(req), None, None)) =>
@@ -217,7 +217,7 @@ class SquadDetailDefinitionUpdateMessageTest extends Specification {
           guid mustEqual PlanetSideGUID(3)
           detail match {
             case SquadDetail(None, None, None, None, None, None, None, None, Some(members)) =>
-              members.size mustEqual 2
+              members.size mustEqual 1
               members.head.index mustEqual 5
               members.head.info match {
                 case Some(SquadPositionDetail(None, None, None, None, Some(char_id), Some(name))) =>
@@ -242,7 +242,7 @@ class SquadDetailDefinitionUpdateMessageTest extends Specification {
           detail match {
             case SquadDetail(None, None, None, None, None, Some(task), None, None, Some(members)) =>
               task mustEqual "\\#FF0000 The \\#ffffff Blades"
-              members.size mustEqual 11
+              members.size mustEqual 10
               //
               members.head.index mustEqual 9
               members.head.info match {
@@ -399,7 +399,7 @@ class SquadDetailDefinitionUpdateMessageTest extends Specification {
           detail match {
             case SquadDetail(None, None, None, None, None, Some(task), None, None, Some(member_list)) =>
               task mustEqual "PSForever Packet Collection"
-              member_list.size mustEqual 11
+              member_list.size mustEqual 10
               member_list.head mustEqual SquadPositionEntry(9,Some(
                 SquadPositionDetail(
                   Some(false),
@@ -516,8 +516,7 @@ class SquadDetailDefinitionUpdateMessageTest extends Specification {
           .Field1(0)
           .LeaderCharId(1221560L)
           .Members(List(
-            SquadPositionEntry(6, SquadPositionDetail().Player(0L, "")),
-            SquadPositionEntry(255, None)
+            SquadPositionEntry(6, SquadPositionDetail().Player(0L, ""))
           ))
       )
       val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
@@ -540,8 +539,7 @@ class SquadDetailDefinitionUpdateMessageTest extends Specification {
           .Leader(42631712L, "Jaako")
           .Field3(556403L)
           .Members(List(
-            SquadPositionEntry(0, SquadPositionDetail().Player(0L, "")),
-            SquadPositionEntry(255, None)
+            SquadPositionEntry(0, SquadPositionDetail().Player(0L, ""))
           ))
       )
       val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
@@ -593,8 +591,7 @@ class SquadDetailDefinitionUpdateMessageTest extends Specification {
             SquadPositionEntry(3, SquadPositionDetail().Role("The Princess")),
             SquadPositionEntry(2, SquadPositionDetail().Role("The Prince")),
             SquadPositionEntry(1, SquadPositionDetail().Role("The Queen")),
-            SquadPositionEntry(0, SquadPositionDetail().Role("The King")),
-            SquadPositionEntry(255, None)
+            SquadPositionEntry(0, SquadPositionDetail().Role("The King"))
           ))
       )
       val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
@@ -606,8 +603,7 @@ class SquadDetailDefinitionUpdateMessageTest extends Specification {
         PlanetSideGUID(3),
         SquadDetail()
           .Members(List(
-            SquadPositionEntry(5, SquadPositionDetail.Closed),
-            SquadPositionEntry(255, None)
+            SquadPositionEntry(5, SquadPositionDetail.Closed)
           ))
       )
       val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
@@ -620,8 +616,7 @@ class SquadDetailDefinitionUpdateMessageTest extends Specification {
         PlanetSideGUID(7),
         SquadDetail()
           .Members(List(
-            SquadPositionEntry(0, SquadPositionDetail().Role("Commander")),
-            SquadPositionEntry(255, None)
+            SquadPositionEntry(0, SquadPositionDetail().Role("Commander"))
           ))
       )
       val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
@@ -635,8 +630,7 @@ class SquadDetailDefinitionUpdateMessageTest extends Specification {
           .Members(List(
             SquadPositionEntry(6, SquadPositionDetail()
               .Role("ADV Hacker")
-              .Requirements(Set(CertificationType.AdvancedHacking))),
-            SquadPositionEntry(255, None)
+              .Requirements(Set(CertificationType.AdvancedHacking)))
           ))
       )
       val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
@@ -648,8 +642,7 @@ class SquadDetailDefinitionUpdateMessageTest extends Specification {
         PlanetSideGUID(3),
         SquadDetail()
           .Members(List(
-          SquadPositionEntry(5, SquadPositionDetail().Player(1218249L, "Duckmaster43")),
-          SquadPositionEntry(255, None)
+          SquadPositionEntry(5, SquadPositionDetail().Player(1218249L, "Duckmaster43"))
         ))
       )
       val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
@@ -671,8 +664,7 @@ class SquadDetailDefinitionUpdateMessageTest extends Specification {
             SquadPositionEntry(3, SquadPositionDetail().Role("")),
             SquadPositionEntry(2, SquadPositionDetail().Role("")),
             SquadPositionEntry(1, SquadPositionDetail().Role("")),
-            SquadPositionEntry(0, SquadPositionDetail().Role("")),
-            SquadPositionEntry(255, None)
+            SquadPositionEntry(0, SquadPositionDetail().Role(""))
           ))
       )
       val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
@@ -715,7 +707,7 @@ class SquadDetailDefinitionUpdateMessageTest extends Specification {
         PlanetSideGUID(3),
         SquadDetail
           .Task("PSForever Packet Collection")
-          .Members((0 to 9).map { index => SquadPositionEntry(index, position) }.reverse.toList :+ SquadPositionEntry(255, None))
+          .Members((0 to 9).map { index => SquadPositionEntry(index, position) }.reverse.toList)
       )
       val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
       pkt mustEqual string_mixed
